/*
 * 2D Game Engine 
 * ECS.cpp:
 * Based on pikuma.com 2D game engine in C++ and Lua course
 * Copyright (c) 2021 986-Studio. All rights reserved.
 *
 * Created by Manoël Trapier on 11/02/2021.
 */

#include <ECS.h>

/* Entity */

/* TODO: this should be moved to the header file for optimisation purposes */
uint32_t Entity::getId() const
{
    return this->id;
}

/* System */
void System::addEntity(Entity entity)
{
    this->entities.push_back(entity);
}

void System::removeEntity(Entity entity)
{
    this->entities.erase(std::remove_if(this->entities.begin(), this->entities.end(), [&entity](Entity other)
    {
        return other.getId() == entity.getId();
    }), this->entities.end());
}

std::vector<Entity> System::getEntities() const
{
    return this->entities;
}

const Signature& System::getComponentSignature() const
{
    return this->componentSignature;
}